package akka.common;

import java.util.Collection;
import java.util.LinkedList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import akka.actor.ActorRef;
import akka.actor.UntypedActor;
import akka.common.WatchActor.WatchMe;

public class CollectorActor extends UntypedActor {

	private static final Logger LOGGER = LoggerFactory.getLogger(CollectorActor.class);

	private final Collection<Object> elements;

	public CollectorActor(ActorRef watchActor) {
		this(new LinkedList<Object>(), watchActor);
	}

	public CollectorActor(final Collection<Object> elements, ActorRef watchActor) {
		super();
		this.elements = elements;

		watchActor.tell(new WatchMe(getSelf()), getSelf());
	}

	@Override
	public void onReceive(Object message) throws Exception {
		elements.add(message);
	}

	@Override
	public void postStop() throws Exception {
		LOGGER.info("stopped: " + elements.size());
		super.postStop();
	}
}
